Index: pplinux/linuxnew/Build
diff -u /dev/null pplinux/linuxnew/Build:1.8
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/Build	Mon May  2 14:12:51 2005
@@ -0,0 +1,62 @@
+#!/bin/sh
+
+source ../../Config.sh
+
+pp_clean_local () {
+#    if [ "$PP_PRODUCT" = "lara_bmc_test" ]; then
+#    	make -C patches clean
+#    fi
+    make mrproper
+    return 0
+}
+
+pp_build_local () {
+    if [ ! -x "$FW_TOPDIR/pplinux/u-boot/tools/mkimage" ]; then
+	echo "Build u-boot first, please!"
+	return 1
+    fi
+
+    if [ "$PP_PRODUCTION" = "1" ]; then
+	config="${PP_BOARD}_${PP_SUBBOARD}_production_defconfig"
+    else
+	if [ "$PP_FEAT_WLAN" = "1" ]; then
+	    config="${PP_BOARD}_${PP_SUBBOARD}_wlan_defconfig"
+	elif [ "$PP_PRODUCT" = "lara_bmc_test" ]; then
+	    config="${PP_BOARD}_${PP_SUBBOARD}_ipmi_defconfig"
+	else
+	    config="${PP_BOARD}_${PP_SUBBOARD}_defconfig"
+	fi
+    fi
+
+#    # apply patches (only needed for lara_bmc_test)
+#    if [ "$PP_PRODUCT" = "lara_bmc_test" ]; then
+#    	make -C patches || return 1
+#    fi
+
+    # generate default config file
+    pushd arch/ppc/configs
+	echo -n "Using ${config} ... "
+	if [ -e "${config}" ]; then
+	    cp -f "${config}" peppercon_defconfig || return 1
+	else
+	    echo "not found. bailing out."
+	    return 1
+	fi
+    popd
+
+    # set environment variable LNX_FASTBUILD to 1 if you want to do a fast
+    # kernel build without oldconfig/dep/clean - this is ignored for final!
+    # Do this on command line and *not here* in this file!
+
+    # NOTE: "oldconfig" must be separate!
+    if [ "$PP_BUILD_TYPE" = "final" -o "$LNX_FASTBUILD" != "1" ]; then
+	# regular build
+	make peppercon_config oldconfig \
+	  && make dep clean uImage modules modules_install pp_install
+    else
+	# for kernel hackers: fast build
+	make uImage modules modules_install pp_install
+    fi
+}
+
+pp_do "$@"
Index: pplinux/linuxnew/Makefile
diff -u pplinux/linuxnew/Makefile:1.1.323.1 pplinux/linuxnew/Makefile:1.4
--- pplinux/linuxnew/Makefile:1.1.323.1	Thu Feb  3 10:00:11 2005
+++ pplinux/linuxnew/Makefile	Wed Apr  6 11:53:10 2005
@@ -3,9 +3,13 @@
 SUBLEVEL = 26
 EXTRAVERSION =
 
+USE_REAL_CROSS = 1
+include ../../Config.mk
+
 KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 
-ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
+#ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
+ARCH := ppc
 KERNELPATH=kernel-$(shell echo $(KERNELRELEASE) | sed -e "s/-//g")
 
 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
@@ -19,7 +23,7 @@
 HOSTCC  	= gcc
 HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
 
-CROSS_COMPILE 	=
+CROSS_COMPILE 	= $(CROSS)
 
 #
 # Include the make variables (CC, etc...)
@@ -82,14 +86,17 @@
 # makefile but the arguement can be passed to make if needed.
 #
 
-MODLIB	:= $(INSTALL_MOD_PATH)/lib/modules/$(KERNELRELEASE)
+INSTALL_MOD_PATH=$(DESTDIR)
+export INSTALL_MOD_PATH
+
+MODLIB := $(INSTALL_MOD_PATH)/lib/modules/$(KERNELRELEASE)
 export MODLIB
 
 #
 # standard CFLAGS
 #
 
-CPPFLAGS := -D__KERNEL__ -I$(HPATH)
+CPPFLAGS := -D__KERNEL__ -I$(HPATH) -include $(FW_TOPDIR)/include/pp/features.h $(FW_CPPFLAGS)
 
 CFLAGS := $(CPPFLAGS) -Wall -Wstrict-prototypes -Wno-trigraphs -O2 \
 	  -fno-strict-aliasing -fno-common
@@ -359,6 +366,13 @@
 	@echo \#define UTS_RELEASE \"$(KERNELRELEASE)\" > .ver
 	@echo \#define LINUX_VERSION_CODE `expr $(VERSION) \\* 65536 + $(PATCHLEVEL) \\* 256 + $(SUBLEVEL)` >> .ver
 	@echo '#define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))' >>.ver
+	@echo \#define UTS_BOARDTYPE \"$(PP_BOARD)\" >> .ver
+	@echo \#define UTS_PRODUCTTYPE \"$(PP_PRODUCT)\" >> .ver
+	@if [ "$(PP_PRODUCTION)" = "1" ]; then \
+	  echo \#define UTS_PRODUCTION \"$(PP_PRODUCTION)\" >> .ver; \
+	else \
+	  echo \#define UTS_PRODUCTION \"0\" >> .ver; \
+	fi
 	@mv -f .ver $@
 
 comma	:= ,
@@ -400,14 +414,12 @@
 	$(MAKE) -C $(patsubst _mod_%, %, $@) CFLAGS="$(CFLAGS) $(MODFLAGS)" MAKING_MODULES=1 modules
 
 .PHONY: modules_install
-modules_install: _modinst_ $(patsubst %, _modinst_%, $(SUBDIRS)) _modinst_post
+modules_install: _modinst_ $(patsubst %, _modinst_%, $(SUBDIRS))
 
 .PHONY: _modinst_
 _modinst_:
 	@rm -rf $(MODLIB)/kernel
-	@rm -f $(MODLIB)/build
 	@mkdir -p $(MODLIB)/kernel
-	@ln -s $(TOPDIR) $(MODLIB)/build
 
 # If System.map exists, run depmod.  This deliberately does not have a
 # dependency on System.map since that would run the dependency tree on
@@ -500,7 +512,7 @@
 ifdef CONFIG_MODVERSIONS
 	$(MAKE) update-modverfile
 endif
-	scripts/mkdep -- `find $(FINDHPATH) \( -name SCCS -o -name .svn \) -prune -o -follow -name \*.h ! -name modversions.h -print` > .hdepend
+	find $(FINDHPATH) \( -name SCCS -o -name .svn \) -prune -o -follow -name \*.h ! -name modversions.h -print0 | xargs -0 scripts/mkdep -- | cat > .hdepend
 	scripts/mkdep -- init/*.c > .depend
 
 ifdef CONFIG_MODVERSIONS
@@ -579,3 +591,42 @@
 	. scripts/mkversion > .version ; \
 	$(RPM) -ta $(TOPDIR)/../$(KERNELPATH).tar.gz ; \
 	rm $(TOPDIR)/../$(KERNELPATH).tar.gz
+
+pp_install:
+ifeq ($(PP_PRODUCTION),1)
+
+# PP_PRODUCTION
+
+ifeq ($(PP_BOARD),lara)
+    ifeq ($(PP_SUBBOARD),none)
+	cp -f arch/$(ARCH)/boot/images/uImage /tftpboot/zImage.lara.prod
+    else
+	cp -f arch/$(ARCH)/boot/images/uImage /tftpboot/zImage.lara.$(PP_SUBBOARD).prod
+    endif
+  else
+    ifeq ($(PP_BOARD),eric)
+	cp -f arch/$(ARCH)/boot/images/uImage /tftpboot/zImage.eric.prod
+    endif
+  endif
+
+else
+
+# !PP_PRODUCTION
+
+  ifeq ($(PP_BOARD),lara)
+    ifeq ($(PP_SUBBOARD),none)
+	cp -f arch/$(ARCH)/boot/images/uImage /tftpboot/zImage.lara.$(USER)
+    else
+	cp -f arch/$(ARCH)/boot/images/uImage /tftpboot/zImage.lara.$(PP_SUBBOARD).$(USER)
+    endif
+  else
+    ifeq ($(PP_BOARD),eric)
+	cp -f arch/$(ARCH)/boot/images/uImage /tftpboot/zImage.eric.$(USER)
+    endif
+  endif
+
+  ifeq ($(PP_BUILD_TYPE),final)
+	cp -f arch/$(ARCH)/boot/images/uImage $(FW_TOPDIR)/mkfirmware/zImage.bin
+  endif
+
+endif
Index: pplinux/linuxnew/Documentation/Configure.help
diff -u pplinux/linuxnew/Documentation/Configure.help:1.1.323.1 pplinux/linuxnew/Documentation/Configure.help:1.5
--- pplinux/linuxnew/Documentation/Configure.help:1.1.323.1	Thu Feb  3 10:00:11 2005
+++ pplinux/linuxnew/Documentation/Configure.help	Wed Apr  6 11:28:07 2005
@@ -320,6 +320,14 @@
   If you are not sure, say Y; apart from resulting in a 66 KB bigger
   kernel, it won't hurt.
 
+Support for big physical area reservation
+CONFIG_BIGPHYS_AREA
+  Enables kernel support for reserving large areas of physical memory
+  at boot-time for use by certain device drivers (such as video
+  framegrabbers, etc.) which require it. To use this feature, boot
+  the kernel with the boot-time option 'bigphysarea=nnn' where
+  'nnn' is the number of pages (a page is usually 4K) to reserve.
+
 Timer and CPU usage LEDs
 CONFIG_LEDS
   If you say Y here, the LEDs on your machine will be used
Index: pplinux/linuxnew/arch/ppc/Makefile
diff -u pplinux/linuxnew/arch/ppc/Makefile:1.1.323.1 pplinux/linuxnew/arch/ppc/Makefile:1.2
--- pplinux/linuxnew/arch/ppc/Makefile:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/Makefile	Thu Feb  3 11:35:37 2005
@@ -25,6 +25,10 @@
 HOSTCFLAGS	+= -I$(TOPDIR)/arch/$(ARCH)
 CPP		= $(CC) -E $(CFLAGS)
 
+ifdef CONFIG_405
+CFLAGS := $(CFLAGS) -mcpu=405
+endif
+
 ifdef CONFIG_4xx
 CFLAGS := $(CFLAGS) -Wa,-m405
 endif
Index: pplinux/linuxnew/arch/ppc/config.in
diff -u pplinux/linuxnew/arch/ppc/config.in:1.1.323.1 pplinux/linuxnew/arch/ppc/config.in:1.3
--- pplinux/linuxnew/arch/ppc/config.in:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/config.in	Fri Apr 29 10:43:28 2005
@@ -91,6 +91,8 @@
 	 Sycamore	CONFIG_SYCAMORE		\
 	 Tivo		CONFIG_TIVO 		\
 	 Walnut		CONFIG_WALNUT		\
+	 Peppercon405GP	CONFIG_PEPPERCON_405GP	\
+	 Peppercon405EP	CONFIG_PEPPERCON_405EP	\
 	 Xilinx-ML300	CONFIG_XILINX_ML300"	Walnut
 
    if [ "$CONFIG_EP405" = "y" ]; then
@@ -295,6 +297,7 @@
 
 if [ "$CONFIG_4xx" = "y" -o "$CONFIG_8xx" = "y" ]; then
   bool 'Math emulation' CONFIG_MATH_EMULATION
+  bool 'Support for big physical area reservation' CONFIG_BIGPHYS_AREA
 fi
 
 if [ "$CONFIG_4xx" = "y" ]; then
@@ -396,6 +399,14 @@
     define_bool CONFIG_440GX y
   fi
 
+  if [ "$CONFIG_PEPPERCON_405GP" = "y" ]; then
+    define_bool CONFIG_PEPPERCON y
+    define_bool CONFIG_405GP y
+  elif [ "$CONFIG_PEPPERCON_405EP" = "y" ]; then
+    define_bool CONFIG_PEPPERCON y
+    define_bool CONFIG_405EP y
+  fi
+
 #
 # Set options based on processor implementation
 #
@@ -404,6 +415,7 @@
        "$CONFIG_NP405GS" = "y" -o "$CONFIG_STB03xxx" = "y" -o \
        "$CONFIG_405LP" = "y" -o "$CONFIG_405GPR" = "y" ]; then
     define_bool CONFIG_IBM_OCP y
+    define_bool CONFIG_PPC_OCP y
     define_bool CONFIG_GEN550 y
     define_bool CONFIG_405 y
   fi
@@ -567,6 +579,7 @@
 bool 'Select task to kill on out of memory condition' CONFIG_OOM_KILLER
 
 source drivers/pci/Config.in
+source drivers/hotplug/Config.in
 
 bool 'Support for hot-pluggable devices' CONFIG_HOTPLUG
 
@@ -716,6 +729,9 @@
 if [ "$CONFIG_40x" != "y" -a "$CONFIG_8xx" != "y" ]; then
   bool 'Support for VGA Console' CONFIG_VGA_CONSOLE
 fi
+if [ "$CONFIG_PEPPERCON" = "y" ]; then
+  define_bool CONFIG_DUMMY_CONSOLE y
+fi
  source drivers/video/Config.in
 if [ "$CONFIG_FB" = "y" -a "$CONFIG_ALL_PPC" = "y" ]; then
   bool 'Backward compatibility mode for Xpmac' CONFIG_FB_COMPAT_XPMAC
Index: pplinux/linuxnew/arch/ppc/boot/Makefile
diff -u pplinux/linuxnew/arch/ppc/boot/Makefile:1.1.323.1 pplinux/linuxnew/arch/ppc/boot/Makefile:1.2
--- pplinux/linuxnew/arch/ppc/boot/Makefile:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/boot/Makefile	Thu Feb  3 11:35:37 2005
@@ -17,7 +17,8 @@
 AFLAGS	+= -D__BOOTER__
 OBJCOPY_ARGS = -O elf32-powerpc
 
-MKIMAGE				:= $(TOPDIR)/scripts/mkuboot.sh
+#MKIMAGE				:= $(TOPDIR)/scripts/mkuboot.sh
+MKIMAGE				:= $(TOPDIR)/../u-boot/tools/mkimage
 
 lib/zlib.a: lib/zlib.c
 	$(MAKE) -C lib
@@ -25,9 +26,12 @@
 images/vmlinux.gz: $(TOPDIR)/vmlinux
 	$(MAKE) -C images vmlinux.gz
 
+images/vmlinux.bz2: $(TOPDIR)/vmlinux
+	$(MAKE) -C images vmlinux.bz2
+
 # Subdirs and tools needed for each.  Assume we always need to go into
 # 'simple' unless told otherwise.
-subdir-y			:= lib common simple
+subdir-y			:= lib common
 subdir-$(CONFIG_ALL_PPC)	:= chrp pmac prep
 tools-$(CONFIG_ALL_PPC)		:= addnote mknote hack-coff mkprep
 tools-$(CONFIG_4xx)		:= mktree
@@ -66,13 +70,11 @@
 endif
 
 # Make an image for PPCBoot / U-Boot.
-uImage: $(MKIMAGE) images/vmlinux.gz
-	$(CONFIG_SHELL) $(MKIMAGE) -A ppc -O linux -T kernel \
-	-C gzip -a 00000000 -e 00000000 \
+uImage: images/vmlinux.bz2
+	$(MKIMAGE) -A ppc -O linux -T kernel -C bzip2 -a 00000000 -e 00000000 \
 	-n 'Linux-$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)' \
-	-d images/vmlinux.gz images/vmlinux.UBoot
+	-d images/vmlinux.bz2 images/vmlinux.UBoot
 	ln -sf vmlinux.UBoot images/uImage
-	rm -f ./mkuboot
 
 # These are subdirs with files not normally rm'ed. -- Tom
 clean:
Index: pplinux/linuxnew/arch/ppc/boot/images/Makefile
diff -u pplinux/linuxnew/arch/ppc/boot/images/Makefile:1.1.323.1 pplinux/linuxnew/arch/ppc/boot/images/Makefile:1.2
--- pplinux/linuxnew/arch/ppc/boot/images/Makefile:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/boot/images/Makefile	Thu Feb  3 11:35:37 2005
@@ -4,9 +4,14 @@
 
 include $(TOPDIR)/Rules.make
 
-vmlinux.gz: $(TOPDIR)/vmlinux
-	$(OBJCOPY) --strip-all -S -O binary $(TOPDIR)/vmlinux vmlinux
+vmlinux.gz: vmlinux
 	gzip -vf9 vmlinux
 
+vmlinux.bz2: vmlinux
+	bzip2 -vf9 vmlinux
+
+vmlinux: $(TOPDIR)/vmlinux
+	$(OBJCOPY) --strip-all -S -O binary $(TOPDIR)/vmlinux vmlinux
+
 clean:
 	rm -f sImage vmapus vmlinux* miboot* zImage* zvmlinux* uImage
Index: pplinux/linuxnew/arch/ppc/kernel/Makefile
diff -u pplinux/linuxnew/arch/ppc/kernel/Makefile:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/Makefile:1.2
--- pplinux/linuxnew/arch/ppc/kernel/Makefile:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/Makefile	Thu Feb  3 11:35:37 2005
@@ -34,7 +34,8 @@
 export-objs			:= ppc_ksyms.o time.o ocp.o ppc4xx_setup.o \
 					ppc4xx_dma.o ppc4xx_sgdma.o \
 					ppc4xx_stbdma.o ppc4xx_pm.o \
-					gt64260_common.o
+					gt64260_common.o \
+					ppc405_pcimcs.o
 
 obj-y				:= entry.o traps.o irq.o idle.o time.o misc.o \
 					process.o signal.o ptrace.o align.o \
@@ -60,7 +61,7 @@
 obj-$(CONFIG_SERIAL_TEXT_DEBUG)	+= gt64260_dbg.o
 endif
 
-obj-$(CONFIG_40x)		+= ppc4xx_setup.o
+obj-$(CONFIG_40x)		+= ppc4xx_setup.o ppc4xx_i2c.o
 obj-$(CONFIG_4xx)		+= ocp.o todc_time.o
 ifeq ($(CONFIG_XILINX_OCP),y)
 obj-$(CONFIG_4xx)		+= xilinx_pic.o
@@ -73,6 +74,7 @@
 ifeq ($(CONFIG_PCI),y)
 obj-$(CONFIG_40x)		+= ppc405_pci.o
 obj-$(CONFIG_4xx)		+= indirect_pci.o pci_auto.o
+obj-$(CONFIG_PEPPERCON)		+= ppc405_pcimcs.o
 endif
 obj-$(CONFIG_44x)		+= ppc4xx_pic.o ibm44x_common.o
 obj-$(CONFIG_440GP)		+= ibm440gp_common.o
Index: pplinux/linuxnew/arch/ppc/kernel/ocp.c
diff -u pplinux/linuxnew/arch/ppc/kernel/ocp.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/ocp.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/ocp.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/ocp.c	Fri Apr 29 10:43:28 2005
@@ -327,7 +327,7 @@
 {
 	struct	ocp_device	*dev;
 
-	DBG(("ocp: ocp_add_one_device(vendor: %x, function: %x, index: %d)...\n", vendor, function, index));
+	DBG(("ocp: ocp_add_one_device(vendor: %x, function: %x, index: %d)...\n", def->vendor, def->function, def->index));
 
 	/* Can't be called after ocp driver init */
 	if (ocp_inited)
@@ -349,7 +349,7 @@
 	list_add_tail(&dev->link, &ocp_devices);
 	up_write(&ocp_devices_sem);
 
-	DBG(("ocp: ocp_add_one_device(vendor: %x, function: %x, index: %d)...done.\n", vendor, function, index));
+	DBG(("ocp: ocp_add_one_device(vendor: %x, function: %x, index: %d)...done.\n", def->vendor, def->function, def->index));
 
 	return 0;
 }
Index: pplinux/linuxnew/arch/ppc/kernel/pci.c
diff -u pplinux/linuxnew/arch/ppc/kernel/pci.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/pci.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/pci.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/pci.c	Thu Feb  3 11:35:37 2005
@@ -22,7 +22,7 @@
 #include <asm/irq.h>
 #include <asm/uaccess.h>
 
-#undef DEBUG
+#define DEBUG
 
 #ifdef DEBUG
 #define DBG(x...) printk(x)
Index: pplinux/linuxnew/arch/ppc/kernel/pci_auto.c
diff -u pplinux/linuxnew/arch/ppc/kernel/pci_auto.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/pci_auto.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/pci_auto.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/pci_auto.c	Thu Feb  3 11:35:37 2005
@@ -29,7 +29,7 @@
 
 #define	PCIAUTO_IDE_MODE_MASK		0x05
 
-#undef DEBUG
+#define DEBUG
 
 #ifdef DEBUG
 #define DBG(x...) printk(x)
Index: pplinux/linuxnew/arch/ppc/kernel/ppc405_pci.c
diff -u pplinux/linuxnew/arch/ppc/kernel/ppc405_pci.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/ppc405_pci.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/ppc405_pci.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/ppc405_pci.c	Thu Feb  3 11:35:37 2005
@@ -31,6 +31,7 @@
  *  675 Mass Ave, Cambridge, MA 02139, USA.
  */
 
+#include <linux/config.h>
 #include <linux/pci.h>
 #include <asm/io.h>
 #include <asm/system.h>
@@ -41,6 +42,8 @@
 #include <asm/pci-bridge.h>
 #include <asm/ocp.h>
 
+#define CONFIG_DEBUG_BRINGUP
+
 #ifdef  CONFIG_DEBUG_BRINGUP
 #define DBG(x...) printk(x)
 #else
Index: pplinux/linuxnew/arch/ppc/kernel/ppc405_pcimcs.c
diff -u /dev/null pplinux/linuxnew/arch/ppc/kernel/ppc405_pcimcs.c:1.1
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/arch/ppc/kernel/ppc405_pcimcs.c	Thu Feb  3 11:35:37 2005
@@ -0,0 +1,293 @@
+/*
+ * FILE NAME: ppc405_pcimcs.c
+ *
+ * BRIEF MODULE DESCRIPTION:
+ * machine check save pci access and configuration routines.
+ * These routines may also be used in case a certain PCI
+ * resource is physically not present. The according functions
+ * will return an error code.
+ *
+ * Author: Peppercon AG
+ *         Thomas Breitfeld <thomas@peppercon.de>
+ *
+ *  This program is free software; you can redistribute  it and/or modify it
+ *  under  the terms of  the GNU General  Public License as published by the
+ *  Free Software Foundation;  either version 2 of the  License, or (at your
+ *  option) any later version.
+ *
+ *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
+ *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
+ *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
+ *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
+ *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
+ *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
+ *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
+ *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  You should have received a copy of the  GNU General Public License along
+ *  with this program; if not, write  to the Free Software Foundation, Inc.,
+ *  675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/pci.h>
+#include <linux/module.h>
+#include <asm/io.h>
+#include <asm/system.h>
+#include <asm/machdep.h>
+#include <asm/ppc405_pcimcs.h>
+#include <linux/init.h>
+#include <asm/pci-bridge.h>
+
+/*
+ * NOTE:
+ *
+ *   after a data machine check the NIP is set to the next instruction in
+ *   stream. Normally it should be the "eieio" instruction following our
+ *   I/O operation. But there are cases where this isn't true, e.g. if an
+ *   interupt occured. In this case the NIP is set to the first
+ *   instruction of the interrupt handler. This prevents the execution of
+ *   our exception handler. Solution: disable interrupts.
+ */
+u8 mcs_in_8(volatile u8 * addr, int * error)
+{
+	u_long flags;
+	u32 err;
+	u32 data;
+
+	local_irq_save(flags);
+        __asm__ __volatile__(
+			     "       lbz%U2%X2 %0,%2\n"
+			     "1:     eieio\n"
+			     "       li %1,0\n"
+			     "2:\n"
+			     ".section .fixup,\"ax\"\n"
+			     "3:     li %1,-1\n"
+			     "       b 2b\n"
+			     ".section __ex_table,\"a\"\n"
+			     "       .align 2\n"
+			     "       .long 1b,3b\n"
+			     ".text"
+			     : "=r" (data), "=r" (err)
+			     : "m" (*addr) );
+	local_irq_restore(flags);
+	*error = err;
+	return data;
+}
+
+u16 mcs_in_le16(volatile u16 * addr, int * error)
+{
+	u_long flags;
+	u32 err;
+	u32 data;
+
+	local_irq_save(flags);
+        __asm__ __volatile__(
+			     "       lhbrx %0,0,%2\n"
+			     "1:     eieio\n"
+			     "       li %1,0\n"
+			     "2:\n"
+			     ".section .fixup,\"ax\"\n"
+			     "3:     li %1,-1\n"
+			     "       b 2b\n"
+			     ".section __ex_table,\"a\"\n"
+			     "       .align 2\n"
+			     "       .long 1b,3b\n"
+			     ".text"
+			     : "=r" (data), "=r" (err)
+			     : "r" (addr), "m" (*addr) );
+	local_irq_restore(flags);
+	*error = err;
+	return data;
+}
+
+u32 mcs_in_le32(volatile u32 * addr, int * error)
+{
+	u_long flags;
+	u32 err;
+	u32 data;
+
+	local_irq_save(flags);
+	__asm__ __volatile__(
+			     "       lwbrx %0,0,%2\n"
+			     "1:     eieio\n"
+			     "       li %1,0\n"
+			     "2:\n"
+			     ".section .fixup,\"ax\"\n"
+			     "3:     li %1,-1\n"
+			     "       b 2b\n"
+			     ".section __ex_table,\"a\"\n"
+			     "       .align 2\n"
+			     "       .long 1b,3b\n"
+			     ".text"
+			     : "=r" (data), "=r" (err)
+			     : "r" (addr), "m" (*addr) );
+	local_irq_restore(flags);
+	*error = err;
+	return data;
+}
+
+void mcs_out_8(u32 data, volatile u8 * addr, int * error)
+{
+	u_long flags;
+	u32 err;
+
+	local_irq_save(flags);
+        __asm__ __volatile__(
+			     "       stb%U0%X0 %2,%0\n"
+			     "1:     eieio\n"
+			     "       li %1,0\n"
+			     "2:\n"
+			     ".section .fixup,\"ax\"\n"
+			     "3:     li %1,-1\n"
+			     "       b 2b\n"
+			     ".section __ex_table,\"a\"\n"
+			     "       .align 2\n"
+			     "       .long 1b,3b\n"
+			     ".text"
+			     : "=m" (*addr), "=r" (err)
+			     : "r" (data) );
+	local_irq_restore(flags);
+	*error = err;
+}
+
+void mcs_out_le16(u32 data, volatile u16 * addr, int * error)
+{
+	u_long flags;
+	u32 err;
+
+	local_irq_save(flags);
+        __asm__ __volatile__(
+			     "       sthbrx %2,0,%3\n"
+			     "1:     eieio\n"
+			     "       li %1,0\n"
+			     "2:\n"
+			     ".section .fixup,\"ax\"\n"
+			     "3:     li %1,-1\n"
+			     "       b 2b\n"
+			     ".section __ex_table,\"a\"\n"
+			     "       .align 2\n"
+			     "       .long 1b,3b\n"
+			     ".text"
+			     : "=m" (*addr), "=r" (err)
+			     : "r" (data), "r" (addr) );
+	local_irq_restore(flags);
+	*error = err;
+}
+
+void mcs_out_le32(u32 data, volatile u32 * addr, int * error)
+{
+	u_long flags;
+	u32 err;
+
+	local_irq_save(flags);
+        __asm__ __volatile__(
+			     "       stwbrx %2,0,%3\n"
+			     "1:     eieio\n"
+			     "       li %1,0\n"
+			     "2:\n"
+			     ".section .fixup,\"ax\"\n"
+			     "3:     li %1,-1\n"
+			     "       b 2b\n"
+			     ".section __ex_table,\"a\"\n"
+			     "       .align 2\n"
+			     "       .long 1b,3b\n"
+			     ".text"
+			     : "=m" (*addr), "=r" (err)
+			     : "r" (data), "r" (addr) );
+	local_irq_restore(flags);
+	*error = err;
+}
+
+/*
+ *  config space access with caught
+ *  Machine Check exception. This is necessary
+ *  as we try to detect our VGA chip with an
+ *  config cycle, means also in case it is switched
+ *  off. The advanced error reporting leads in this
+ *  case to a machine check exception that needs
+ *  to be handled
+ *  mcs - means machine check save
+ */
+#define MCS_read(val, addr, type, op, errp) *val = op((type)(addr), errp)
+#define MCS_write(val, addr, type, op, errp) op((val), (type*)(addr), errp)
+ 
+#define MCS_PCI_CONFIG_OP(rw, size, type, op, mask)                        \
+int                                                                        \
+mcs_pci_##rw##_config_##size(struct pci_dev *dev, int offset, type value)  \
+{                                                                          \
+  u32 error;                                                               \
+  struct pci_controller* hose = dev->sysdata;                              \
+  out_be32(hose->cfg_addr, ((offset & 0xfc) << 24) | (dev->devfn << 16)    \
+           | (dev->bus->number << 8) | 0x80);                              \
+  MCS_##rw(value, hose->cfg_data + (offset & mask), type, op, &error);     \
+  return error;                                                            \
+}
+
+MCS_PCI_CONFIG_OP(read, byte, u8*, mcs_in_8, 3)
+MCS_PCI_CONFIG_OP(read, word, u16*, mcs_in_le16, 2)
+MCS_PCI_CONFIG_OP(read, dword, u32*, mcs_in_le32, 0)
+MCS_PCI_CONFIG_OP(write, byte, u8, mcs_out_8, 3)
+MCS_PCI_CONFIG_OP(write, word, u16, mcs_out_le16, 2)
+MCS_PCI_CONFIG_OP(write, dword, u32, mcs_out_le32, 0)
+ 
+#if 0
+/*
+ * I'll better leave an example in here to show
+ * to what the macros will expand... ;-)
+ */
+int
+mcs_pci_read_config_byte(struct pci_dev *dev, int offset, u8* value)
+{
+  u32 error;
+  struct pci_controller* hose = dev->sysdata;
+  out_be32(hose->cfg_addr,
+           ((offset & 0xfc) << 24) | (dev->devfn << 16)
+           | (dev->bus->number << 8) | 0x80);
+  *value = mcs_in_8((u8*)hose->cfg_data + (offset & 3), &error);
+  return error;
+}
+#endif
+
+#define CFG_read(val, addr, type, op) *val = op((type)(addr))
+#define CFG_write(val, addr, type, op) op((type*)(addr), (val))
+ 
+#define FIX_PCI_CONFIG_OP(rw, size, type, op, mask)                        \
+void                                                                       \
+fix_pci_##rw##_config_##size(u32 cfg_addr, u32 cfg_data,                   \
+			     int offset, type value)                       \
+{                                                                          \
+  out_be32((u32*)cfg_addr, ((offset & 0xfc) << 24) | (0 << 16)             \
+           | (0 << 8) | 0x80);                                             \
+  CFG_##rw(value, cfg_data + (offset & mask), type, op);                   \
+}
+ 
+FIX_PCI_CONFIG_OP(read,  byte,  u8*,  in_8,   3)
+FIX_PCI_CONFIG_OP(read,  word,  u16*, in_le16,   2)
+FIX_PCI_CONFIG_OP(read,  dword, u32*, in_le32,  0)
+FIX_PCI_CONFIG_OP(write, byte,  u8,   out_8,   3)
+FIX_PCI_CONFIG_OP(write, word,  u16,  out_le16,  2)
+FIX_PCI_CONFIG_OP(write, dword, u32,  out_le32, 0)
+
+
+EXPORT_SYMBOL(mcs_in_8);
+EXPORT_SYMBOL(mcs_in_le16);
+EXPORT_SYMBOL(mcs_in_le32);
+EXPORT_SYMBOL(mcs_out_8);
+EXPORT_SYMBOL(mcs_out_le16);
+EXPORT_SYMBOL(mcs_out_le32);
+EXPORT_SYMBOL(mcs_pci_read_config_byte);
+EXPORT_SYMBOL(mcs_pci_read_config_word);
+EXPORT_SYMBOL(mcs_pci_read_config_dword);
+EXPORT_SYMBOL(mcs_pci_write_config_byte);
+EXPORT_SYMBOL(mcs_pci_write_config_word);
+EXPORT_SYMBOL(mcs_pci_write_config_dword);
+EXPORT_SYMBOL(fix_pci_read_config_byte);
+EXPORT_SYMBOL(fix_pci_read_config_word);
+EXPORT_SYMBOL(fix_pci_read_config_dword);
+EXPORT_SYMBOL(fix_pci_write_config_byte);
+EXPORT_SYMBOL(fix_pci_write_config_word);
+EXPORT_SYMBOL(fix_pci_write_config_dword);
+
